import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class fraction_as_bigint_bug2 {
    public void run() throws IOException {
        in = new FastScanner(new FileInputStream("fraction.in"));
        out = new PrintWriter("fraction.out");

        int n = in.nextInt();
        int k = in.nextInt();
        int r = in.nextInt();

        ArrayList<Integer> ans = new ArrayList<>(0);
        BigInteger n1 = BigInteger.ONE.shiftLeft(n);
        BigInteger k1 = BigInteger.ONE.shiftLeft(k);
        BigInteger ndivk = BigInteger.ONE.shiftLeft(n - k);
        BigInteger ndivk2 = ndivk.divide(BigInteger.valueOf(2));
        for (int i = 1; i <= r; i++) {
            BigInteger iv = BigInteger.valueOf(i);
            BigInteger div = n1.divide(iv);
            int rem = n1.mod(iv).intValue();
            if (2 * rem >= i) {
                div = div.add(BigInteger.ONE);
            }
            BigInteger mv = div.multiply(iv);
            BigInteger kv = mv;
            kv = mv.shiftRight(n - k);
            if (mv.mod(ndivk).compareTo(ndivk2) >= 0) {
                kv = kv.add(BigInteger.ONE);
            }
            if (!kv.equals(k1)) {
                ans.add(i);
            }
        }

        out.println(ans.size());
        for (int x : ans) {
            out.print(x + " ");
        }


        out.close();
    }

    FastScanner in;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        new fraction_as_bigint_bug2().run();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) throws IOException {
            br = new BufferedReader(new InputStreamReader(in));
        }

        String next() {
            try {
                while (st == null || !st.hasMoreTokens()) {
                    st = new StringTokenizer(br.readLine());
                }
            } catch (IOException e) {
                System.err.println(e);
                System.exit(1);
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}